Bug 199924 - kpartx wwid naming problems with partitions on LUN
kpartx wwid naming problems with partitions on LUN
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: device-mapper-multipath (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ben Marzinski
Depends On:
  Show dependency treegraph
Reported: 2006-07-24 08:08 EDT by Jan Wildeboer
Modified: 2010-01-11 21:26 EST (History)
10 users (show)

See Also:
Fixed In Version: 5.0.0
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-02-13 15:21:28 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Jan Wildeboer 2006-07-24 08:08:38 EDT
Description of problem:

When the wwid of a LUN ends in a digit and has partitions on it, kpartx will add
p<numebr of partition> to the wwid. However, when the wwid ends in a letter,
kpartx will just add the number, not the letter 'p'. This is causing some
problems with SAN fabric changes.

How reproducible:

Set up LUNs in SAN, add partitions to them and check kpartx output

Actual results:

wwid that ends in digit get p<number> added, wwid that end in a letter get just
the number added.

Expected results:

consistent output. Either always p<number> or always just <number>

Additional info:

Seems to be a problem with ATA namespace not allowing the letter-p<number>
combination according to Heinz Mauelshagen.
Comment 1 Ben Marzinski 2006-08-03 11:35:24 EDT
Any more information on the <letters>-p<numbers> problem?  This is a pretty easy
issue to fix. It's just that i need an easy-to-distinguish partition delimiter.
My personal prefernce would be <multipath_name>-p<partition_number> or
<multipath_name>-part<partition_number>. I'd like to know if there is a problem
with them, and exactly what else won't work. Switching the '-' for a '_' would
be fine, if that is allowable. Just using <multipath_name>p<partition_number>
works fine with the user_friendly_names option set, but it's hard to see
appended on the WWID names.

Also, Somebody needs to convince me that changing the naming scheme from U4 to
U5 is a good idea, because it seems like a recipe for disaster to me.

A better solution for RHEL4 would be to have the customers who are effected by
this use the user_friendly_names option by adding

user_friendly_names  yes

to the "defaults" section of their config file. This would force all multipath
names into the mpath<number> format, which would mean that partitions would
always look like mpath<number>p<partition_number>. If they need to make sure
that the names are consistent across multiple machines, they simply need to
copy the /var/lib/multipath/bindings file from a machine where multipathing has
already been set up to the other machines that will access the same devices.
This file holds the WWID to user_friendly_names bindings.

That should fix the problem unless I am misunderstanding it. For RHEL5 I will
make sure that there is a consistent delimiter.
Comment 2 Ben Marzinski 2006-11-27 16:56:08 EST
There is now a consistent delimiter 'p'. If people need it to change, they must
exit /etc/rc.sysinit and /etc/udev/rules.d/40-multipath.rules, and remove the
"-p p" option from the kpartx command
Comment 3 Ben Marzinski 2007-02-13 15:21:28 EST
As I said in Comment #1 and #2, this is fixed in RHEL 5. It will not be fixed in
RHEL4, because it will break existing setups.

Note You need to log in before you can comment on or make changes to this bug.